=== debian/changelog ===
dietlibc (0.34~cvs20160606-19) unstable; urgency=medium

  * fix FTBFS with GCC 15 by sticking to -std=gnu99 (Closes: #1096523)
  * bump Policy
  * apply lintian

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 26 Aug 2025 22:29:59 +0000

dietlibc (0.34~cvs20160606-18) unstable; urgency=medium

  [ Helge Deller ]
  * hppa brown paper bag fix

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Jul 2024 02:50:42 +0200

dietlibc (0.34~cvs20160606-17) unstable; urgency=medium

  [ Helge Deller ]
  * make 5/6-args syscalls generally more reliable on hppa

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 09 Jul 2024 22:18:21 +0200

dietlibc (0.34~cvs20160606-16) unstable; urgency=medium

  [ Helge Deller ]
  * fix socketfns test crash in recvfrom()

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 08 Jul 2024 18:37:00 +0200

dietlibc (0.34~cvs20160606-15) unstable; urgency=medium

  * upload to unstable reverting GCC 14 test B-D
  * d/copyright: complete licence review, entirely new
    (cf. #1067946)
  * update description and patch headers
  * un-mark fadvise test as expect-fail on ARM (works now)
  * mark socketfns test as expect-fail on parisc (hppa),
    as qemu-user needs to be updated to match changed Linux kernel

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 06 Jul 2024 17:28:41 +0200

dietlibc (0.34~cvs20160606-14exp1) experimental; urgency=high

  [ Debian Janitor, lintian-brush ]
  * fix d/copyright, d/watch, Homepage, UMEGAYA and d/changelog
  * bump debhelper and S-V

  [ Bastian Germann ]
  * d/watch: Scan for other compression formats

  [ Helge Deller ]
  * Update hppa defs (Closes: #974690) (Closes: #1030998)

  [ Thorsten Glaser ]
  * avoid rmdir failing with ENOENT
  * add -ffreestanding to libc builds (Closes: #1069365)
  * test swp instruction for armel builds (Closes: #1017537)
  * B-D on GCC 14 and fix FTBFS with it (Closes: #1074910)
    uploading to experimental for that
  * Unbreak building on architectures with LFS/t64 in dpkg-buildflags
  * More fixing of the stack protector, pthreads, etc.
  * Apply lintian fixes

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 05 Jul 2024 00:20:35 +0200

dietlibc (0.34~cvs20160606-14) unstable; urgency=low

  * Ask dpkg-buildflags to keep LTO disabled. (Closes: #1015386)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 19 Jul 2022 19:07:37 +0200

dietlibc (0.34~cvs20160606-12) unstable; urgency=low

  [ John David Anglin ]
  * Fix FTBFS due to bad syscall argument layout (Closes: #944489)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 10 Nov 2019 21:44:57 +0100

dietlibc (0.34~cvs20160606-11) unstable; urgency=low

  * d/patches/bugfixes/cflags.diff: retain main CFLAGS on amd64, x32
    which adds missing EXTRACFLAGS on x32 (Closes: #943429)
  * Bump Policy; slightly update packaging
  * Update lintian overrides
  * d/patches/bugfixes/x32-struct-member-sizes.diff: Correct some
    struct member sizes, partially spotted by Bernhard Übelacker,
    fix smashed stack from undersized buffer (Closes: #925359)
  * idem: fix useconds_t not being unsigned while here

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 24 Oct 2019 21:47:00 +0200

dietlibc (0.34~cvs20160606-10) unstable; urgency=high

  * Back out “add latest syscalls” backport: the .s files and most
    arches are not yet capable of handling 5-/6-argument syscalls

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 08 Oct 2018 22:29:45 +0200

dietlibc (0.34~cvs20160606-9) unstable; urgency=high

  [ Larry Doolittle ]
  * Fix rare utime test failure

  [ Thorsten Glaser ]
  * Policy 4.2.1.1
    - Handle “terse” build option
    - I *think* we can R³=no
  * Backport some things from upstream
    - fix for FTBFS on IA64
    - some bounds and null/uninitialised plus warning fixes
    - add latest syscalls
  * Plug stack overflow in regex engine (FTBFS on alpha)
  * Fix weak symbols (FTBFS) on IA64
  * Hook up ppoll (needed for socketcall Debian patch) on IA64
  * Fix pthread SIGBUS (during atomic operations) on several
    architectures by making _pthread_fastlock.__spinlock and
    pthread_once_t “long”s (changes ABI but we’re static-only)
  * Fix pasto in UMEGAYA metadata

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 07 Oct 2018 00:19:36 +0200

dietlibc (0.34~cvs20160606-8) unstable; urgency=medium

  [ Thorsten Glaser ]
  * Fix typo in <stddef.h> causing warning on offsetof() uses.
  * Refresh all patches.
  * Update VCS-* URIs for Salsa.
  * Fix build log scanner warnings.
  * Address lintian concerns.

  [ Larry Doolittle ]
  * Fix applications using newer Linux headers. (Closes: #883534)
  * Hook up the unshare() syscall.

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 01 Jul 2018 20:32:34 +0200

dietlibc (0.34~cvs20160606-7) unstable; urgency=medium

  * Make builds reproducible on ARM by working around ld.bfd issue.

 -- Christian Seiler <christian@iwakd.de>  Mon, 03 Jul 2017 06:32:54 +0200

dietlibc (0.34~cvs20160606-6) unstable; urgency=medium

  [ Héctor Orón Martínez ]
  * debian/control: drop myself from maintainers field.

  [ Christian Seiler ]
  * arm64: fix accidental register reuse in __testandset (Closes: #851379)
  * Add Thorsten Glaser to Uploaders.

 -- Christian Seiler <christian@iwakd.de>  Sat, 18 Feb 2017 12:10:09 +0100

dietlibc (0.34~cvs20160606-5) unstable; urgency=medium

  * hppa: fix pthread_atfork() and getsockopt() FTBFS bugs
  * alpha: fix FTBFS due to same TCB / TP issue
  * alpha: fix __testandset return value
  * alpha: fix setjmp() (previously completely broken)
  * Unit tests: mark tst-calloc as expected failure on arm64 for now.
    This build failure is not a regression: the test was enabled only in
    the latest version, and would have failed im previous versions as well.

 -- Christian Seiler <christian@iwakd.de>  Wed, 25 Jan 2017 22:25:27 +0100

dietlibc (0.34~cvs20160606-4) unstable; urgency=medium

  * Also run unittests linked against -lpthread.
  * Only show unit test error output at the very end.
  * Don't override errno_location in libpthread if TLS is enabled.
    (Closes: #850276)

