=== debian/control ===
Source: dietlibc
Section: devel
Priority: optional
Homepage: https://www.fefe.de/dietlibc/
Maintainer: Christian Seiler <christian@iwakd.de>
Uploaders: Thorsten Glaser <tg@mirbsd.de>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), dh-exec
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/dietlibc.git
Vcs-Browser: https://salsa.debian.org/debian/dietlibc

Package: dietlibc-dev
Section: libdevel
Architecture: alpha amd64 arm arm64 armeb armel armhf hppa i386 ia64 mips mipsel mips64el powerpc powerpcspe ppc64 ppc64el s390 s390x sparc sparc64 x32
Depends: ${misc:Depends}
Multi-Arch: same
Suggests: dietlibc-doc
Description: diet libc - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, ARM, hppa (PA-RISC), IA-64, MIPS, PowerPC, S/390, SPARC
 and x86 under GPLv2.
 .
 This package is used to compile programs with the diet libc.
 .
 The diet libc also supports dynamic linking, but this has been
 temporarily disabled because of problems with it.

Package: dietlibc-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: dietlibc-dev
Description: diet libc documentation - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, ARM, hppa (PA-RISC), IA-64, MIPS, PowerPC, S/390, SPARC
 and x86 under GPLv2.
 .
 This package contains the documentation for the diet libc.
