=== debian/tests/control ===
Tests: hello
Depends: dietlibc-dev, build-essential
