=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://www.fefe.de/dietlibc/ dietlibc-([0-9.]*)@ARCHIVE_EXT@
